Subject: bug#36109: GNU Privacy Assistant

From: Efraim Flashner <[email-masked]>
Date: Thu, 18 Jul 2019 12:51:28 +0300

On Thu, Jul 18, 2019 at 11:43:30AM +0300, Efraim Flashner wrote:
> On Wed, Jul 17, 2019 at 11:14:07PM -0400, Raghav Gururajan wrote:
> > Apart from the errors showed on the GUI, running gpa via terminal shows
> > following additional error messages:
> > 
> > ** Message: 23:11:17.193: tool to start the agent is not available
> > ** Message: 23:11:20.515: error connecting an UI server: Invalid value
> > passed to IPC - assuming not running
> > 
> I tried running: './pre-inst-env guix environment --pure --ad-hoc gpa -- gpa'
> 
> console message of:
> ** Message: 11:38:44.814: tool to start the agent is not available
> 
> pop-up message of:
> The GPGME library returned an unexpected
> error at confdialog.c:1472. The error was:
> 
> Unsupported protocol
> 
> This is either an installation problem or a bug in GPA.
> GPA will now try to recover from this error.
> 
> This was followed by another message:
> Fatal Error in GPGME library
> (invoked from file options.c, line 302):
> 
> Unsupported protocol
> 
> The application will be terminated
> 
> and from the console:
> ** Message: 11:40:37.432: error connecting an UI server: Invalid value passed to IPC - assuming not running
> 
> and then it exited on me.
> 
> so it looks like it might be missing something, but if GPA or GMGME is
> missing something remains to be seen.
> 

The two lines referenced above reference gpgme, and
'guix gc -R $(guix build gpa) | grep gpgme' does show that gpa does
reference gpgme. However, 'guix gc -R $(guix build gpa) | grep gnupg'
doesn't show anything, so it seems that this might be where the problem
is.
'./pre-inst-env guix environment --pure --ad-hoc gnupg gpa -- gpa' does
allow gpa to start without any errors.

While persuing this bug I noticed that gpa looks for gpg2keys_ldap,
which may have been depreciated in favor of dirmngr_ldap. I don't
(knowingly) fetch keys over ldap so I don't know if the fix I made
actually does anything. With it 'guix gc -R ...' does reference gnupg,
but it doesn't on its own cause the program to suddenly work without
having gnupg explicitly installed.

It seems that many distros separate the dirmngr binary which is required
for GPA to work from the gnupg binary, but if that's the case then it
should still find dirmngr with my patch and work for some things

On the other hand 'guix gc -R $(guix build gpgme) | grep gnupg' doesn't
yield any results, so there could be a problem there too.

-- 
Efraim Flashner   <[email-masked]>   אפרים פלשנר
GPG key = A28B F40C 3E55 1372 662D  14F7 41AA E7DC CA3D 8351
Confidentiality cannot be guaranteed on emails sent or received unencrypted